/*FreeMind - A Program for creating and viewing Mindmaps
*Copyright (C) 2000-2006 Joerg Mueller, Daniel Polansky, Christian Foltin, Dimitri Polivaev and others.
*
*See COPYING for Details
*
*This program is free software; you can redistribute it and/or
*modify it under the terms of the GNU General Public License
*as published by the Free Software Foundation; either version 2
*of the License, or (at your option) any later version.
*
*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.
*
*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*
 * Created on 18.06.2005
 * Copyright (C) 2005 Dimitri Polivaev
 */
package freemind.modes.attributes;

/**
 * @author Dimitri Polivaev
 * 18.06.2005
 */
public class Attribute {
    private String name;
    private String value;
    /**
     */
    public Attribute(String name) {
        this.name = name;
        this.value = "";
    }
    public Attribute(String name, String value) {
        this.name = name;
        this.value = value;
    }
    /**
     * @param pAttribute deep copy.
     */
    public Attribute(Attribute pAttribute) {
        this.name = pAttribute.name;
        this.value = pAttribute.value;
    }
    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }
    public String getValue() {
        return value;
    }
    public void setValue(String value) {
        this.value = value;
    }
    
    public String toString() {
        return "[" + name + ", "+ value + "]";
    }
}
